package agents; 

import sim.engine.*;
import sim.util.*;
 
public class Data {
	
    public String[] fileheaders ={"run", "sim", "time", "dates", "r", "t", "df", "dif", "mMales", "SD","mFemales" ,"SD",
    				"gMean","SD", "Males", "Females", "meanDates", "meanTime",
    				"N[1]","N[2]","N[3]","N[4]","N[5]","N[6]","N[7]","N[8]","N[9]","N[10]",};
    public Bag data = null;   
    double mAttractiveT = 0.0;
	double fAttractiveT = 0.0;
	double mAttractiveSquaredT = 0.0;
	double fAttractiveSquaredT = 0.0;
	double mfAttractiveT = 0.0;
	double n = 0.0;
	double mSD = 0.0;
	double fSD = 0.0;
	double r = 0.0;
	double t = 0.0;
	double    df = 0;
	double dif = 0.0;
	double meanDif  =0;
	double dates = 0;
	double failedDates = 0;
	double totalDates = 0;
	double males = 0;
	double females = 0;
	double meanMale = 0.0;
	double meanFemale = 0.0;
	double meanTotal = 0.0;
	double gSD = 0.0;
	public int runCount = 0;
	public int simCount = 0;
    
	  public Bag getData(SimState state){
	    	AgentsSimulation as = (AgentsSimulation)state;
	          data = new Bag(); 
	         
	          data.add((double)(runCount+1)); //run count
	  		  data.add((double)simCount);		//sim count
	          data.add((double)((AgentsSimulation)state).schedule.getSteps());
	          data.add(n);
	          data.add(r);
	          data.add(t);
	          data.add(df);
	          data.add(meanDif);
	          data.add(meanMale);
	          data.add(mSD);
	          data.add(meanFemale);
	          data.add(fSD);
	          data.add(meanTotal);
	          data.add(gSD);
	          data.add(males);
	          data.add(females);
	          data.add(average(as.meanMarriageAgeDates));
	          data.add(average(as.meanMarriageAgeTime));
	          
	          for(int i=0; i < 10; i++)
	        	  data.add((double)as.numberMated[i]);
	          return data;
	              }
	
	
	public void correlation(){
		if(n>2){
			double x = mfAttractiveT/n - (mAttractiveT/n * fAttractiveT/n);
			double y1 = mAttractiveSquaredT/n - (mAttractiveT/n*mAttractiveT/n);
			double y2 = fAttractiveSquaredT/n - (fAttractiveT/n*fAttractiveT/n);
			r = x/Math.sqrt(y1*y2);
			mSD=  Math.sqrt(y1);
			fSD=  Math.sqrt(y2);
			gSD = Math.sqrt((y1+y2)/2);
		}
	}
	
	public void means(){
		if(n>0){
			meanMale = mAttractiveT/n;
			meanFemale = fAttractiveT/n;
			meanTotal = (meanMale + meanFemale)/2.0;
			meanDif = dif/n;
		}
	}
	
	public void t_value(){
		if(n>2){
			t = r*Math.sqrt(n-2)/Math.sqrt(1-(r*r));
			df = (int)(n-1.0);
		}
	}
	
	public void getData(double maleAttractiveness, double femalemaleAttractiveness){
		n ++;
		males ++;
		females ++;
		dif += Math.abs(maleAttractiveness -femalemaleAttractiveness);
		mAttractiveT += maleAttractiveness;
		fAttractiveT += femalemaleAttractiveness;
		mAttractiveSquaredT += maleAttractiveness * maleAttractiveness;
		fAttractiveSquaredT += femalemaleAttractiveness * femalemaleAttractiveness;
		mfAttractiveT += maleAttractiveness * femalemaleAttractiveness;
	}
	

  
    
    public int countClass(final Class c, Bag bag){
    	int x = 0;
    	
    	for(int i=0; i< bag.numObjs;i++)
    		if(bag.get(i).getClass().equals(c))
    			x++;
    	
    	return x;
    }
    
	/**
	 * returns the mean of an array of doubles, excluding zeros
	 */
	public double average(double[] vector){
		double sum = 0;
		double size = 0;
		for(int i = 0; i < vector.length; i++){
			if(vector[i] < 1)
				break;
			else{
			sum += vector[i];
			size++;
			}
		}
		if(size > 0)
			return sum/size;
		else return 0;
	}
    
    
    
    
    
}//end class



