package agents; 
import java.lang.String;
import java.lang.reflect.Field;

import sim.engine.SimState;

 
public class HandleData implements java.io.Serializable {
      WriteData write;           
      /** This code should be reused for each simulation **/
      public HandleData(SimState state, String folderName, String fileName, boolean saveToFile){
            if(saveToFile)
                 write = new WriteData(folderName, fileName);
              }

      public void printPramsToConsole(SimState state){
            Class a =  state.getClass(); // gets the runtime class
            Field[] x = a.getDeclaredFields(); // gets the declared fields, which we will use 
            // to print out the parameter values
            String b = " ";
            for(int i=0;i<x.length;i++)
                try{                        //there can be errors that we must catch
                	b = x[i].toString();
                     int j = b.lastIndexOf(".");
                     b = b.substring(j+1);
                     b = b + "  " + x[i].get(state).toString();
                     System.out.println(b);
                    }
                 catch(NullPointerException e){
                      System.out.println("NullPointerException; " + e);
                    }
                 catch(IllegalArgumentException e){
                      System.out.println("IllegalArgumentException; " + e);
                    }
                 catch (IllegalAccessException e){
                      System.out.println("IllegalAccessException; " + e);
                    }
              }
              
       public void printPramsToFile(SimState state){
             String b;
             Class a =  state.getClass(); // gets the runtime class
             Field[] x = a.getDeclaredFields(); // gets the declared fields, which we will use                                                    // to print out the parameter values
             for(int i=0;i<x.length;i++)
                 try{                        //there can be errors that we must catch
                	 b = x[i].toString();
                     int j = b.lastIndexOf(".");
                     b = b.substring(j+1);
                     b = b + "  " + x[i].get(state).toString();
                     write.writeStringln(b);
                     }
                 catch(NullPointerException e){
                       //System.out.println("NullPointerException; " + e);
                     }
                  catch(IllegalArgumentException e){
                       System.out.println("IllegalArgumentException; " + e);
                     }
                  catch (IllegalAccessException e){
                       System.out.println("IllegalAccessException; " + e);
                                    }
              }
              
              /** end use this code each time **/
              
        public void getData(SimState state){                                                         
              }

        public void printHeadersToConsole(Data data){
             String header = "";
             for(int i=0; i<data.fileheaders.length;i++)
                  header += (data.fileheaders[i] + "\t");
                  System.out.println(header);
              }

        public void printDataToConsole(Data data){
             String thedata = "";

			for(int i=0; i<data.data.numObjs;i++){
            	   String s = String.format("%2.2f",((Double)data.data.objs[i]).doubleValue());
                   thedata += (s + "\t");                 
              }
			System.out.println(thedata);
        }
              
        public void printHeadersToFile(Data data){
              String header = "";
              for(int i=0; i<data.fileheaders.length;i++)
                  header += (data.fileheaders[i] + "\t");
                  write.writeStringln(header);
              }
              
         public void printDataToFile(Data data){
              String thedata = "";
              for(int i=0; i<data.data.numObjs;i++){
           	   String s = String.format("%2.2f",((Double)data.data.objs[i]).doubleValue());
               thedata += (s + "\t");                 
          }
                   
              write.writeStringln(thedata);
              }
}